commit 38916fd46e44aae1dd6ad4f9be5041c6e80aeef2
Author: freddy77 <freddy77>
Date:   Wed Oct 29 09:56:53 2008 +0000

    improve test for wide charaters

diff --git a/ChangeLog b/ChangeLog
index 207552e..49bc2f5 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Wed Oct 29 10:54:30 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/putdata.c: improve test for wide charaters
+
 Wed Oct 29 10:31:08 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/common.c src/odbc/unittests/common.h:
 	* src/odbc/unittests/cursor1.c src/odbc/unittests/data.c:
@@ -799,4 +802,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2643 2008/10/29 09:33:50 freddy77 Exp $
+$Id: ChangeLog,v 1.2644 2008/10/29 09:56:53 freddy77 Exp $
diff --git a/TODO.freddy b/TODO.freddy
index 9180179..e8d8869 100644
--- a/TODO.freddy
+++ b/TODO.freddy
@@ -50,7 +50,7 @@ test to review
 - data.c (char -> sql_c_char) DONE
 - genparams.c
 - getdata.c DONE
-- putdata.c ??
+- putdata.c DONE
 - blob1.c (SQLGetData test with binary -> char and between chars)
 Is it possible to support direct binding for parameters using different
 encodings? For instance client <-> server iso8859-1 <-> ucs2. It should be
diff --git a/src/odbc/unittests/putdata.c b/src/odbc/unittests/putdata.c
index 3eff23f..254ac2e 100644
--- a/src/odbc/unittests/putdata.c
+++ b/src/odbc/unittests/putdata.c
@@ -2,7 +2,7 @@
 
 /* Test for SQLPutData */
 
-static char software_version[] = "$Id: putdata.c,v 1.11 2008/02/08 09:28:04 freddy77 Exp $";
+static char software_version[] = "$Id: putdata.c,v 1.12 2008/10/29 09:56:53 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static const char test_text[] =
@@ -19,47 +19,72 @@ main(int argc, char *argv[])
 	SQLPOINTER ptr;
 	unsigned char buf[256], *pb;
 	SQLRETURN retcode;
+	int type, lc, sql_type;
 
 	Connect();
 
 	/* create table to hold data */
 	Command(Statement, "CREATE TABLE #putdata (c TEXT NULL, b IMAGE NULL)");
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_LONGVARCHAR, 0, 0, (SQLPOINTER) 123, 0, &ind));
-	/* length required */
-	ind = SQL_LEN_DATA_AT_EXEC(len);
-
-	/* 
-	 * test for char 
-	 */
+	sql_type = SQL_LONGVARCHAR;
+	type = SQL_C_CHAR;
+	lc = 1;
+	for (;;) {
+		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, type, sql_type, 0, 0, (SQLPOINTER) 123, 0, &ind));
+		/* length required */
+		ind = SQL_LEN_DATA_AT_EXEC(len * lc);
+
+		/* 
+		 * test for char 
+		 */
+
+		CHK(SQLPrepare, (Statement, (SQLCHAR *) "INSERT INTO #putdata(c) VALUES(?)", SQL_NTS));
+
+		if (SQLExecute(Statement) != SQL_NEED_DATA)
+			ODBC_REPORT_ERROR("Wrong result executing statement");
+
+		p = test_text;
+		n = 5;
+		if (SQLParamData(Statement, &ptr) != SQL_NEED_DATA)
+			ODBC_REPORT_ERROR("Wrong result from SQLParamData");
+		if (ptr != (SQLPOINTER) 123)
+			ODBC_REPORT_ERROR("Wrong pointer from SQLParamData");
+		while (*p) {
+			int l = strlen(p);
+
+			if (l < n)
+				n = l;
+			if (type == SQL_C_CHAR) {
+				CHK(SQLPutData, (Statement, (char *) p, n));
+			} else {
+				SQLWCHAR buf[256];
+				int i;
+				for (i = 0; i < n; ++i)
+					buf[i] = p[i];
+				CHK(SQLPutData, (Statement, (char *) buf, n * lc));
+			}
+			p += n;
+			n *= 2;
+		}
+		CHK(SQLParamData, (Statement, &ptr));
 
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "INSERT INTO #putdata(c) VALUES(?)", SQL_NTS));
+		if (SQLParamData(Statement, &ptr) != SQL_ERROR)
+			ODBC_REPORT_ERROR("Wrong result from SQLParamData");
 
-	if (SQLExecute(Statement) != SQL_NEED_DATA)
-		ODBC_REPORT_ERROR("Wrong result executing statement");
+		/* check state  and reset some possible buffers */
+		Command(Statement, "DECLARE @i INT");
 
-	p = test_text;
-	n = 5;
-	if (SQLParamData(Statement, &ptr) != SQL_NEED_DATA)
-		ODBC_REPORT_ERROR("Wrong result from SQLParamData");
-	if (ptr != (SQLPOINTER) 123)
-		ODBC_REPORT_ERROR("Wrong pointer from SQLParamData");
-	while (*p) {
-		int l = strlen(p);
+		if (sql_type == SQL_LONGVARCHAR && db_is_microsoft() && db_version_int() >= 0x08000000u) {
+			sql_type = SQL_WLONGVARCHAR;
+			continue;
+		}
 
-		if (l < n)
-			n = l;
-		CHK(SQLPutData, (Statement, (char *) p, n));
-		p += n;
-		n *= 2;
+		if (type != SQL_C_CHAR)
+			break;
+		sql_type = SQL_LONGVARCHAR;
+		type = SQL_C_WCHAR;
+		lc = sizeof(SQLWCHAR);
 	}
-	CHK(SQLParamData, (Statement, &ptr));
-
-	if (SQLParamData(Statement, &ptr) != SQL_ERROR)
-		ODBC_REPORT_ERROR("Wrong result from SQLParamData");
-
-	/* check state  and reset some possible buffers */
-	Command(Statement, "DECLARE @i INT");
 
 	/* update row setting binary field */
 	for (i = 0; i < 255; ++i)
@@ -104,21 +129,28 @@ main(int argc, char *argv[])
 	/* test len == 0 case from ML */
 	CHK(SQLFreeStmt, (Statement, SQL_RESET_PARAMS));
 
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "INSERT INTO #putdata(c) VALUES(?)", SQL_NTS));
+	type = SQL_C_CHAR;
+	for (;;) {
+		CHK(SQLPrepare, (Statement, (SQLCHAR *) "INSERT INTO #putdata(c) VALUES(?)", SQL_NTS));
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_LONGVARCHAR, 0, 0, (PTR) 2, 0, &ind));
+		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, type, SQL_LONGVARCHAR, 0, 0, (PTR) 2, 0, &ind));
 
-	ind = SQL_LEN_DATA_AT_EXEC(0);
+		ind = SQL_LEN_DATA_AT_EXEC(0);
 
-	if ((retcode = SQLExecute(Statement)) != SQL_NEED_DATA) {
-		printf("Wrong result executing statement (retcode=%d)\n", (int) retcode);
-		exit(1);
-	}
-	while (retcode == SQL_NEED_DATA) {
-		retcode = SQLParamData(Statement, &ptr);
-		if (retcode == SQL_NEED_DATA) {
-			SQLPutData(Statement, "abc", 3);
+		if ((retcode = SQLExecute(Statement)) != SQL_NEED_DATA) {
+			printf("Wrong result executing statement (retcode=%d)\n", (int) retcode);
+			exit(1);
+		}
+		while (retcode == SQL_NEED_DATA) {
+			retcode = SQLParamData(Statement, &ptr);
+			if (retcode == SQL_NEED_DATA) {
+				SQLPutData(Statement, "abc", 3);
+			}
 		}
+		if (type != SQL_C_CHAR)
+			break;
+		type = SQL_C_WCHAR;
+		ResetStatement();
 	}
 
 	/* TODO check inserts ... */

